(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@ngx-translate/core'), require('@narik/ui-core'), require('@angular/forms'), require('rxjs/operators'), require('rxjs'), require('@narik/infrastructure'), require('@ng-bootstrap/ng-bootstrap'), require('@angular/common'), require('@narik/app-core'), require('@narik/common'), require('@narik/core'), require('@angular/flex-layout'), require('@angular/animations'), require('angular2-uuid')) :
    typeof define === 'function' && define.amd ? define('@narik/ui-ng-bootstrap', ['exports', '@angular/core', '@ngx-translate/core', '@narik/ui-core', '@angular/forms', 'rxjs/operators', 'rxjs', '@narik/infrastructure', '@ng-bootstrap/ng-bootstrap', '@angular/common', '@narik/app-core', '@narik/common', '@narik/core', '@angular/flex-layout', '@angular/animations', 'angular2-uuid'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.narik = global.narik || {}, global.narik['ui-ng-bootstrap'] = {}), global.ng.core, global.core$1, global.uiCore, global.ng.forms, global.rxjs.operators, global.rxjs, global.infrastructure, global.ngBootstrap, global.ng.common, global.appCore, global.common$1, global.core$2, global.ng.flexLayout, global.ng.animations, global.angular2Uuid));
}(this, (function (exports, core, core$1, uiCore, forms, operators, rxjs, infrastructure, ngBootstrap, common, appCore, common$1, core$2, flexLayout, animations, angular2Uuid) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/input-output-items.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var NARIK_UI_COMPONENT_INPUTS = ["options"];
    /** @type {?} */
    var NARIK_UI_FORM_INPUTS = __spread([
        "id",
        "name",
        "label",
        "disabled",
        "required",
        "readOnly",
        "placeHolder"
    ], NARIK_UI_COMPONENT_INPUTS);
    /** @type {?} */
    var NARIK_DATA_ORIENTED_OUTPUTS = [
        "dataChange",
        "selectedItemChange"
    ];
    /** @type {?} */
    var NARIK_DATA_ORIENTED_INPUTS = __spread([
        "listenForDataChange",
        "dataSource",
        "dataKey",
        "dataUrl",
        "dataInfo",
        "dataProviderKey",
        "dataParameters",
        "moduleKey",
        "dataMethod",
        "dataUrlMethod"
    ], NARIK_UI_FORM_INPUTS);
    /** @type {?} */
    var NARIK_DATA_DISPLAY_VALUE_OUTPUTS = __spread(NARIK_DATA_ORIENTED_OUTPUTS);
    /** @type {?} */
    var NARIK_DATA_DISPLAY_VALUE_INPUTS = __spread([
        "displayField",
        "valueField"
    ], NARIK_DATA_ORIENTED_INPUTS);
    /** @type {?} */
    var NARIK_AUTOCOMPLETE_INPUTS = [
        "displayText",
        "minSearchLength",
        "isLazyLoadData"
    ];
    /** @type {?} */
    var NARIK_CHECKBOX_INPUTS = __spread(["tag"], NARIK_UI_FORM_INPUTS);
    /** @type {?} */
    var NARIK_SELECT_INPUTS = ["multiple"];
    /** @type {?} */
    var NARIK_DATA_TABLE_SELECT_INPUTS = __spread(NARIK_SELECT_INPUTS, [
        "gridOptions"
    ]);
    /** @type {?} */
    var NARIK_DATE_PICKER_INPUTS = __spread(NARIK_UI_FORM_INPUTS);
    /** @type {?} */
    var NARIK_INPUT_INPUTS = __spread([
        "maxlength",
        "type",
        "mask",
        "icon",
        "displayStatus"
    ], NARIK_UI_FORM_INPUTS);

    var NarikNgbAutoComplete = /** @class */ (function (_super) {
        __extends(NarikNgbAutoComplete, _super);
        /**
         * @param {?} injector
         */
        function NarikNgbAutoComplete(injector) {
            var _this = _super.call(this, injector) || this;
            _this.internalChange = false;
            _this.optionData = [];
            return _this;
        }
        Object.defineProperty(NarikNgbAutoComplete.prototype, "displayValue", {
            /**
             * @return {?}
             */
            get: function () {
                return this._displayValue;
            },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                if (this._displayValue !== value) {
                    if (!this.internalChange) {
                        this.setValue(value);
                    }
                    this._displayValue = value;
                }
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @return {?}
         */
        NarikNgbAutoComplete.prototype.ngOnInit = function () {
            var _this = this;
            this.loadDataOnInit = !this.isLazyLoadData;
            _super.prototype.ngOnInit.call(this);
            if (!this.isLazyLoadData) {
                this.search = ( /**
                 * @param {?} text$
                 * @return {?}
                 */function (text$) { return text$.pipe(operators.debounceTime(200), operators.distinctUntilChanged(), operators.map(( /**
                 * @param {?} term
                 * @return {?}
                 */function (term) { return term.length < _this.minSearchLength
                    ? []
                    : _this.optionData
                        .filter(( /**
                 * @param {?} v
                 * @return {?}
                 */function (/**
                 * @param {?} v
                 * @return {?}
                 */ v) { return _this.displayField
                        ? v[_this.displayField]
                        : v.toLowerCase().indexOf(term.toLowerCase()) > -1; }))
                        .map(( /**
                 * @param {?} v
                 * @return {?}
                 */function (/**
                 * @param {?} v
                 * @return {?}
                 */ v) { return (_this.displayField ? v[_this.displayField] : v); }))
                        .slice(0, 10); }))); });
            }
            else {
                /** @type {?} */
                var dataProviderService_1 = this.injector.get(infrastructure.DataProviderService);
                /** @type {?} */
                var dataInfo_1 = this.createDataInfo();
                dataInfo_1.dataMethod = "POST";
                dataInfo_1.actionType = "COMPLETE";
                if (!dataInfo_1.moduleKey) {
                    dataInfo_1.moduleKey = this.injector.get(infrastructure.MODULE_DATA_KEY);
                }
                this.search = ( /**
                 * @param {?} text$
                 * @return {?}
                 */function (text$) { return text$.pipe(operators.debounceTime(200), operators.distinctUntilChanged(), operators.tap(( /**
                 * @param {?} filter
                 * @return {?}
                 */function (/**
                 * @param {?} filter
                 * @return {?}
                 */ filter) {
                    if (filter && filter.length >= _this.minSearchLength) {
                        _this.dataIsLoading = true;
                    }
                })), operators.switchMap(( /**
                 * @param {?} filter
                 * @return {?}
                 */function (/**
                 * @param {?} filter
                 * @return {?}
                 */ filter) {
                    dataInfo_1.dataParameters = {
                        filter: filter
                    };
                    return filter && filter.length >= _this.minSearchLength
                        ? dataProviderService_1.getData(dataInfo_1).pipe(operators.tap(( /**
                         * @param {?} result
                         * @return {?}
                         */function (result) { return (_this.optionData = result); })), operators.finalize(( /**
                         * @return {?}
                         */function () { return (_this.dataIsLoading = false); })))
                        : rxjs.of([]);
                }))); });
            }
        };
        /**
         * @param {?} selectedText
         * @return {?}
         */
        NarikNgbAutoComplete.prototype.setValue = function (selectedText) {
            var _this = this;
            this.internalChange = true;
            if (!this.displayField) {
                this.value = selectedText;
            }
            else {
                if (selectedText) {
                    /** @type {?} */
                    var item = this.optionData.filter(( /**
                     * @param {?} x
                     * @return {?}
                     */function (/**
                     * @param {?} x
                     * @return {?}
                     */ x) { return x[_this.displayField] === selectedText; }))[0];
                    if (item) {
                        this.value = item[this.valueField];
                    }
                    else {
                        this.value = undefined;
                    }
                }
                else {
                    this.value = undefined;
                }
            }
            this.internalChange = false;
        };
        /**
         * @protected
         * @param {?} data
         * @return {?}
         */
        NarikNgbAutoComplete.prototype.useData = function (data) {
            this.optionData = data;
        };
        /**
         * @return {?}
         */
        NarikNgbAutoComplete.prototype.setDisplayText = function () {
            var _this = this;
            this.internalChange = true;
            if (this.value) {
                /** @type {?} */
                var item = this.optionData.filter(( /**
                 * @param {?} x
                 * @return {?}
                 */function (/**
                 * @param {?} x
                 * @return {?}
                 */ x) { return x[_this.valueField] === _this.value; }))[0];
                this.displayValue = item ? item[this.displayField] : this.displayText;
            }
            else {
                this.displayValue = "";
            }
            this.internalChange = false;
        };
        /**
         * @protected
         * @param {?} newValue
         * @param {?} oldValue
         * @return {?}
         */
        NarikNgbAutoComplete.prototype.valueChanged = function (newValue, oldValue) {
            if (newValue !== oldValue && !this.internalChange) {
                this.setDisplayText();
            }
        };
        /**
         * @return {?}
         */
        NarikNgbAutoComplete.prototype.onBlur = function () {
            if (!this.isLazyLoadData) {
                this.setDisplayText();
            }
        };
        return NarikNgbAutoComplete;
    }(uiCore.NarikAutoComplete));
    NarikNgbAutoComplete.decorators = [
        { type: core.Component, args: [{
                    selector: "narik-ngb-autocomplete  , narik-autocomplete ",
                    template: "<div class=\"form-group\">\r\n  <label for=\"{{id}}\">{{label}}</label>\r\n  <div class=\"input-group mb-3\" *ngIf=\"icon\">\r\n    <div class=\"input-group-prepend\">\r\n      <span class=\"input-group-text\"><i class=\"fa fa-{{icon}}\"></i></span>\r\n    </div>\r\n    <ng-container *ngTemplateOutlet=\"inputElement\"></ng-container>\r\n  </div>\r\n  <ng-container *ngIf=\"!icon\">\r\n    <ng-container *ngTemplateOutlet=\"inputElement\"></ng-container>\r\n  </ng-container>\r\n\r\n</div>\r\n<ng-template #inputElement>\r\n  <input (blur)=\"onBlur()\" [required]=\"required\" [(ngModel)]=\"displayValue\" [attr.disabled]=\"disabled || null\"\r\n    type=\"text\" name=\"{{name}}\" class=\"form-control\" [ngbTypeahead]=\"search\" id=\"{{id}}\" placeholder=\"{{placeHolder}}\">\r\n  <input type=\"hidden\" name=\"{{name}}\" [(ngModel)]=\"value\">\r\n</ng-template>",
                    inputs: __spread(NARIK_DATA_DISPLAY_VALUE_INPUTS),
                    outputs: __spread(NARIK_DATA_DISPLAY_VALUE_OUTPUTS),
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(( /**
                             * @return {?}
                             */function () { return NarikNgbAutoComplete; })),
                            multi: true
                        }
                    ],
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    NarikNgbAutoComplete.ctorParameters = function () { return [
        { type: core.Injector }
    ]; };
    NarikNgbAutoComplete.propDecorators = {
        icon: [{ type: core.Input }]
    };
    if (false) {
        /** @type {?} */
        NarikNgbAutoComplete.prototype.internalChange;
        /** @type {?} */
        NarikNgbAutoComplete.prototype.optionData;
        /** @type {?} */
        NarikNgbAutoComplete.prototype.search;
        /** @type {?} */
        NarikNgbAutoComplete.prototype._displayValue;
        /** @type {?} */
        NarikNgbAutoComplete.prototype.icon;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-auto-complete/narik-ngb-auto-complete.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgbAutoCompleteModule = /** @class */ (function () {
        function NarikNgbAutoCompleteModule() {
        }
        return NarikNgbAutoCompleteModule;
    }());
    NarikNgbAutoCompleteModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, forms.FormsModule, ngBootstrap.NgbTypeaheadModule],
                    declarations: [NarikNgbAutoComplete],
                    exports: [NarikNgbAutoComplete],
                    providers: []
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-busy-indicator/narik-ngb-busy-indicator.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgbBusyIndicator = /** @class */ (function () {
        function NarikNgbBusyIndicator() {
        }
        /**
         * @param {?} newState
         * @param {?=} msg
         * @return {?}
         */
        NarikNgbBusyIndicator.prototype.setBusy = function (newState, msg) {
            this.isBusy = newState;
        };
        return NarikNgbBusyIndicator;
    }());
    NarikNgbBusyIndicator.decorators = [
        { type: core.Component, args: [{
                    selector: "narik-ngb-busy-indicator , narik-busy-indicator",
                    template: "<ng-content></ng-content>\r\n<div class=\"loading-panel\" *ngIf=\"isBusy\"></div>\r\n<div *ngIf=\"isBusy\" id=\"loader-wrapper\">\r\n  <div class=\"spinner-border text-primary\" role=\"status\">\r\n    <span class=\"sr-only\">Loading...</span>\r\n  </div>\r\n</div>\r\n",
                    providers: [
                        {
                            provide: appCore.BusyIndicator,
                            useExisting: core.forwardRef(( /**
                             * @return {?}
                             */function () { return NarikNgbBusyIndicator; }))
                        }
                    ],
                    styles: [".loading-panel{background-color:#fff;bottom:0;left:0;opacity:.4;position:absolute;right:0;top:0;width:100%;z-index:50000}#loader-wrapper{height:64px;left:50%;margin-left:-20px;margin-top:-20px;position:absolute;top:50%;width:64px;z-index:1000}"]
                }] }
    ];
    NarikNgbBusyIndicator.propDecorators = {
        isBusy: [{ type: core.Input }]
    };
    if (false) {
        /** @type {?} */
        NarikNgbBusyIndicator.prototype.busyMessage;
        /** @type {?} */
        NarikNgbBusyIndicator.prototype.isBusy;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-busy-indicator/narik-ngb-busy-indicator.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgbBusyIndicatorModule = /** @class */ (function () {
        function NarikNgbBusyIndicatorModule() {
        }
        return NarikNgbBusyIndicatorModule;
    }());
    NarikNgbBusyIndicatorModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, core$1.TranslateModule],
                    declarations: [NarikNgbBusyIndicator],
                    exports: [NarikNgbBusyIndicator],
                    providers: []
                },] }
    ];

    var NarikNgbButtonComponent = /** @class */ (function (_super) {
        __extends(NarikNgbButtonComponent, _super);
        /**
         * @param {?} renderer
         * @param {?} injector
         */
        function NarikNgbButtonComponent(renderer, injector) {
            var _this = _super.call(this, injector) || this;
            _this.renderer = renderer;
            return _this;
        }
        /**
         * @param {?} event
         * @return {?}
         */
        NarikNgbButtonComponent.prototype.onClick = function (event) {
            event.stopPropagation();
        };
        /**
         * @return {?}
         */
        NarikNgbButtonComponent.prototype.ngOnInit = function () {
            _super.prototype.ngOnInit.call(this);
            this.buttonStyle = this.buttonStyle || this.defaultOptions.buttonStyle;
            this.busyFontIcon = this.busyFontIcon || this.defaultOptions.busyFontIcon;
        };
        /**
         * @return {?}
         */
        NarikNgbButtonComponent.prototype.ngAfterViewInit = function () { };
        /**
         * @param {?} e
         * @return {?}
         */
        NarikNgbButtonComponent.prototype.buttonClick = function (e) {
            if (!this.disable && !this.isBusy) {
                this.nClick.emit({
                    sender: this,
                    event: e
                });
            }
        };
        return NarikNgbButtonComponent;
    }(uiCore.NarikButton));
    NarikNgbButtonComponent.decorators = [
        { type: core.Component, args: [{
                    selector: "narik-ngb-button , narik-button ",
                    template: "<button\r\n  ngbTooltip=\"{{(tooltip ?  (tooltip | translate) : '') + ( options.appendShortcutToTooltip && shortcut ? '(' + (shortcut | shortcut) +')' : '' )}}\"\r\n  container=\"body\"\r\n  placement=\"bottom\" (click)=\"buttonClick($event)\" [disabled]=\"disable || isBusy\" class=\"btn btn-{{buttonStyle}}\"\r\n  type=\"button\" [ngClass]='cssClass'>\r\n  <span *ngIf=\"isBusy\" class=\"mx-1 spinner-border spinner-border-sm\" role=\"status\" aria-hidden=\"true\"></span>\r\n  <i *ngIf=\"icon\" class=\"fa fa-{{icon}}\"></i>\r\n  {{ isBusy && busyLabel ? busyLabel : label}}\r\n</button>"
                }] }
    ];
    /** @nocollapse */
    NarikNgbButtonComponent.ctorParameters = function () { return [
        { type: core.Renderer2 },
        { type: core.Injector }
    ]; };
    NarikNgbButtonComponent.propDecorators = {
        onClick: [{ type: core.HostListener, args: ["click", ["$event"],] }]
    };
    __decorate([
        core$2.NarikInject(uiCore.BUTTON_DEFAULT_OPTIONS, {
            buttonStyle: "secondary",
            busyFontIcon: "fa-spinner"
        }),
        __metadata("design:type", Object)
    ], NarikNgbButtonComponent.prototype, "defaultOptions", void 0);
    if (false) {
        /** @type {?} */
        NarikNgbButtonComponent.prototype.defaultOptions;
        /**
         * @type {?}
         * @private
         */
        NarikNgbButtonComponent.prototype.renderer;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-button/narik-ngb-button.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgbButtonModule = /** @class */ (function () {
        function NarikNgbButtonModule() {
        }
        return NarikNgbButtonModule;
    }());
    NarikNgbButtonModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, ngBootstrap.NgbTooltipModule, core$1.TranslateModule, common$1.NarikCommonModule],
                    declarations: [NarikNgbButtonComponent],
                    exports: [NarikNgbButtonComponent],
                    providers: []
                },] }
    ];

    var NarikNgbCheckBox = /** @class */ (function (_super) {
        __extends(NarikNgbCheckBox, _super);
        /**
         * @param {?} injector
         */
        function NarikNgbCheckBox(injector) {
            return _super.call(this, injector) || this;
        }
        return NarikNgbCheckBox;
    }(uiCore.NarikCheckBox));
    NarikNgbCheckBox.decorators = [
        { type: core.Component, args: [{
                    selector: "narik-ngb-checkbox , narik-checkbox",
                    template: "<div class=\"form-check\">\r\n  <input [attr.disabled]=\"disabled || null\" class=\"form-check-input\" type=\"checkbox\"\r\n  [(ngModel)]=\"value\" id=\"{{id}}\">\r\n  <label class=\"form-check-label\" for=\"{{id}}\">\r\n    {{label}}\r\n  </label>\r\n</div>\r\n",
                    inputs: __spread(NARIK_CHECKBOX_INPUTS),
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(( /**
                             * @return {?}
                             */function () { return NarikNgbCheckBox; })),
                            multi: true
                        },
                        {
                            provide: uiCore.NarikCheckBox,
                            useExisting: core.forwardRef(( /**
                             * @return {?}
                             */function () { return NarikNgbCheckBox; }))
                        }
                    ]
                }] }
    ];
    /** @nocollapse */
    NarikNgbCheckBox.ctorParameters = function () { return [
        { type: core.Injector }
    ]; };

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-check-box/narik-ngb-checkbox.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgbCheckBoxModule = /** @class */ (function () {
        function NarikNgbCheckBoxModule() {
        }
        return NarikNgbCheckBoxModule;
    }());
    NarikNgbCheckBoxModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, forms.FormsModule],
                    declarations: [NarikNgbCheckBox],
                    exports: [NarikNgbCheckBox],
                    providers: []
                },] }
    ];

    var NarikNgbCheckBoxList = /** @class */ (function (_super) {
        __extends(NarikNgbCheckBoxList, _super);
        /**
         * @param {?} injector
         */
        function NarikNgbCheckBoxList(injector) {
            var _this = _super.call(this, injector) || this;
            _this.itemsData = [];
            _this._layoutDirection = "vertical";
            return _this;
        }
        Object.defineProperty(NarikNgbCheckBoxList.prototype, "layoutDirection", {
            /**
             * @return {?}
             */
            get: function () {
                return this._layoutDirection;
            },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._layoutDirection = value;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @protected
         * @param {?} data
         * @return {?}
         */
        NarikNgbCheckBoxList.prototype.useData = function (data) {
            this.itemsData = data;
        };
        return NarikNgbCheckBoxList;
    }(uiCore.NarikCheckBoxList));
    NarikNgbCheckBoxList.decorators = [
        { type: core.Component, args: [{
                    selector: "narik-ngb-checkbox-list , narik-checkbox-list",
                    template: "<div class=\"form-group\">\r\n  <label for=\"{{id}}\">{{label}}</label>\r\n  <div class=\"form-check-container p-1 pl-2\">\r\n    <div [ngClass]=\"{ 'vertical-content': layoutDirection == 'vertical' }\">\r\n      <narik-checkbox *ngFor=\"let item of itemsData\" (change)=\"addOrRemove(valueField ? item[valueField] : item)\"\r\n        [tag]=\"valueField ? item[valueField] : item\" label=\"{{ item[displayField] }}\">\r\n      </narik-checkbox>\r\n    </div>\r\n  </div>\r\n</div>\r\n",
                    inputs: __spread(NARIK_DATA_DISPLAY_VALUE_INPUTS),
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(( /**
                             * @return {?}
                             */function () { return NarikNgbCheckBoxList; })),
                            multi: true
                        }
                    ],
                    styles: [".form-check-container{border:1px solid #ced4da;border-radius:.25rem}"]
                }] }
    ];
    /** @nocollapse */
    NarikNgbCheckBoxList.ctorParameters = function () { return [
        { type: core.Injector }
    ]; };
    NarikNgbCheckBoxList.propDecorators = {
        layoutDirection: [{ type: core.Input }]
    };
    if (false) {
        /** @type {?} */
        NarikNgbCheckBoxList.prototype.itemsData;
        /** @type {?} */
        NarikNgbCheckBoxList.prototype._layoutDirection;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-check-box-list/narik-ngb-checkbox-list.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgbCheckBoxListModule = /** @class */ (function () {
        function NarikNgbCheckBoxListModule() {
        }
        return NarikNgbCheckBoxListModule;
    }());
    NarikNgbCheckBoxListModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        NarikNgbCheckBoxModule
                    ],
                    declarations: [NarikNgbCheckBoxList],
                    exports: [NarikNgbCheckBoxList],
                    providers: []
                },] }
    ];

    var NarikNgbDataTable = /** @class */ (function (_super) {
        __extends(NarikNgbDataTable, _super);
        /**
         * @param {?} injector
         * @param {?} changeDetector
         * @param {?} document
         */
        function NarikNgbDataTable(injector, changeDetector, document) {
            var _this = _super.call(this, injector) || this;
            _this.changeDetector = changeDetector;
            _this.document = document;
            return _this;
        }
        return NarikNgbDataTable;
    }(uiCore.NarikDataTable));
    NarikNgbDataTable.decorators = [
        { type: core.Component, args: [{
                    selector: "narik-ngb-data-table , narik-data-table",
                    template: ""
                }] }
    ];
    /** @nocollapse */
    NarikNgbDataTable.ctorParameters = function () { return [
        { type: core.Injector },
        { type: core.ChangeDetectorRef },
        { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] }
    ]; };
    if (false) {
        /**
         * @type {?}
         * @private
         */
        NarikNgbDataTable.prototype.changeDetector;
        /**
         * @type {?}
         * @private
         */
        NarikNgbDataTable.prototype.document;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-data-table/narik-ngb-data-table.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgbDataTableModule = /** @class */ (function () {
        function NarikNgbDataTableModule() {
        }
        return NarikNgbDataTableModule;
    }());
    NarikNgbDataTableModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, forms.FormsModule, core$1.TranslateModule],
                    declarations: [NarikNgbDataTable],
                    exports: [NarikNgbDataTable],
                    providers: []
                },] }
    ];

    var NarikNgbDatePicker = /** @class */ (function (_super) {
        __extends(NarikNgbDatePicker, _super);
        /**
         * @param {?} injector
         */
        function NarikNgbDatePicker(injector) {
            return _super.call(this, injector) || this;
        }
        return NarikNgbDatePicker;
    }(uiCore.NarikDatePicker));
    NarikNgbDatePicker.decorators = [
        { type: core.Component, args: [{
                    selector: "narik-ngb-date-picker , narik-date-picker",
                    template: "<div class=\"form-group\">\r\n  <label for=\"{{id}}\">{{label}}</label>\r\n\r\n  <div class=\"input-group\">\r\n    <input [required]=\"required\" [attr.disabled]=\"disabled || null\" class=\"form-control\" id=\"{{id}}\" placeholder=\"{{placeHolder}}\" name=\"dp\"\r\n      [(ngModel)]=\"value\" ngbDatepicker #d=\"ngbDatepicker\">\r\n    <div class=\"input-group-append\">\r\n      <button class=\"btn btn-outline-secondary\" (click)=\"d.toggle()\" type=\"button\">\r\n        <i class=\"fa fa-calendar-alt\" aria-hidden=\"true\"></i>\r\n      </button>\r\n    </div>\r\n  </div>\r\n\r\n</div>\r\n",
                    inputs: __spread(NARIK_DATE_PICKER_INPUTS),
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(( /**
                             * @return {?}
                             */function () { return NarikNgbDatePicker; })),
                            multi: true
                        }
                    ]
                }] }
    ];
    /** @nocollapse */
    NarikNgbDatePicker.ctorParameters = function () { return [
        { type: core.Injector }
    ]; };

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-date-picker/narik-ngb-date-picker.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgbDatePickerModule = /** @class */ (function () {
        function NarikNgbDatePickerModule() {
        }
        return NarikNgbDatePickerModule;
    }());
    NarikNgbDatePickerModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, forms.FormsModule, ngBootstrap.NgbDatepickerModule, core$1.TranslateModule],
                    declarations: [NarikNgbDatePicker],
                    exports: [NarikNgbDatePicker],
                    providers: [{ provide: ngBootstrap.NgbDateAdapter, useClass: ngBootstrap.NgbDateNativeAdapter }]
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-date-picker/public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    var NarikNgbInput = /** @class */ (function (_super) {
        __extends(NarikNgbInput, _super);
        /**
         * @param {?} injector
         */
        function NarikNgbInput(injector) {
            return _super.call(this, injector) || this;
        }
        Object.defineProperty(NarikNgbInput.prototype, "icon", {
            /**
             * @return {?}
             */
            get: function () {
                return this._icon;
            },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._icon = value;
            },
            enumerable: false,
            configurable: true
        });
        return NarikNgbInput;
    }(uiCore.NarikInput));
    NarikNgbInput.decorators = [
        { type: core.Component, args: [{
                    selector: "narik-ngb-input , narik-input",
                    template: "<div class=\"form-group \">\r\n  <label for=\"{{id}}\">{{label}}</label>\r\n  <div class=\"input-group mb-3\" *ngIf=\"icon\">\r\n    <div class=\"input-group-prepend\">\r\n      <span class=\"input-group-text\"><i class=\"fa fa-{{icon}}\"></i></span>\r\n    </div>\r\n    <ng-container *ngTemplateOutlet=\"inputElement\"></ng-container>\r\n  </div>\r\n  <ng-container *ngIf=\"!icon\">\r\n    <ng-container *ngTemplateOutlet=\"inputElement\"></ng-container>\r\n  </ng-container>\r\n\r\n</div>\r\n<ng-template #inputElement>\r\n  <input [(ngModel)]=\"value\" [attr.disabled]=\"disabled || null\" type=\"{{type}}\" name=\"{{name}}\" [required]=\"required\"\r\n    class=\"form-control\" id=\"{{id}}\" placeholder=\"{{placeHolder}}\">\r\n</ng-template>",
                    inputs: __spread(NARIK_INPUT_INPUTS),
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(( /**
                             * @return {?}
                             */function () { return NarikNgbInput; })),
                            multi: true
                        }
                    ]
                }] }
    ];
    /** @nocollapse */
    NarikNgbInput.ctorParameters = function () { return [
        { type: core.Injector }
    ]; };
    NarikNgbInput.propDecorators = {
        icon: [{ type: core.Input }]
    };
    if (false) {
        /** @type {?} */
        NarikNgbInput.prototype._icon;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-input/narik-ngb-input.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgbInputModule = /** @class */ (function () {
        function NarikNgbInputModule() {
        }
        return NarikNgbInputModule;
    }());
    NarikNgbInputModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, forms.FormsModule],
                    declarations: [NarikNgbInput],
                    exports: [NarikNgbInput],
                    providers: []
                },] }
    ];

    var NarikNgbRadioGroup = /** @class */ (function (_super) {
        __extends(NarikNgbRadioGroup, _super);
        /**
         * @param {?} injector
         */
        function NarikNgbRadioGroup(injector) {
            var _this = _super.call(this, injector) || this;
            _this.itemsData = [];
            _this._layoutDirection = "vertical";
            return _this;
        }
        Object.defineProperty(NarikNgbRadioGroup.prototype, "layoutDirection", {
            /**
             * @return {?}
             */
            get: function () {
                return this._layoutDirection;
            },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._layoutDirection = value;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @protected
         * @param {?} data
         * @return {?}
         */
        NarikNgbRadioGroup.prototype.useData = function (data) {
            this.itemsData = data;
        };
        return NarikNgbRadioGroup;
    }(uiCore.NarikRadioGroup));
    NarikNgbRadioGroup.decorators = [
        { type: core.Component, args: [{
                    selector: "narik-ngb-radio-group , narik-radio-group",
                    template: "<div class=\"form-group\">\r\n  <label for=\"{{id}}\">{{label}}</label>\r\n  <div class=\"form-check-container p-1 pl-2\">\r\n    <div class=\"form-check \" [ngClass]=\"{'form-check-inline': layoutDirection==='horizontal'}\"\r\n      *ngFor=\"let item of itemsData;let i=index\">\r\n      <input [required]=\"required\" [attr.disabled]=\"disabled || null\" class=\"form-check-input\" type=\"radio\" name=\"{{name}}\" id=\"{{id+i}}\"\r\n        value=\"{{item[valueField]}}\" checked>\r\n      <label class=\"form-check-label\" for=\"{{id+i}}\">\r\n        {{item[displayField]}}\r\n      </label>\r\n    </div>\r\n  </div>\r\n</div>\r\n",
                    inputs: __spread(NARIK_DATA_DISPLAY_VALUE_INPUTS),
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(( /**
                             * @return {?}
                             */function () { return NarikNgbRadioGroup; })),
                            multi: true
                        }
                    ],
                    styles: [".form-check-container{border:1px solid #ced4da;border-radius:.25rem}"]
                }] }
    ];
    /** @nocollapse */
    NarikNgbRadioGroup.ctorParameters = function () { return [
        { type: core.Injector }
    ]; };
    NarikNgbRadioGroup.propDecorators = {
        layoutDirection: [{ type: core.Input }]
    };
    if (false) {
        /** @type {?} */
        NarikNgbRadioGroup.prototype.itemsData;
        /** @type {?} */
        NarikNgbRadioGroup.prototype._layoutDirection;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-radio/narik-ngb-radio.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgbRadioGroupModule = /** @class */ (function () {
        function NarikNgbRadioGroupModule() {
        }
        return NarikNgbRadioGroupModule;
    }());
    NarikNgbRadioGroupModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, forms.FormsModule],
                    declarations: [NarikNgbRadioGroup],
                    exports: [NarikNgbRadioGroup],
                    providers: []
                },] }
    ];

    var NarikNgbSelect = /** @class */ (function (_super) {
        __extends(NarikNgbSelect, _super);
        /**
         * @param {?} injector
         */
        function NarikNgbSelect(injector) {
            var _this = _super.call(this, injector) || this;
            _this.optionData = [];
            return _this;
        }
        /**
         * @protected
         * @param {?} data
         * @return {?}
         */
        NarikNgbSelect.prototype.useData = function (data) {
            this.optionData = data;
        };
        return NarikNgbSelect;
    }(uiCore.NarikSelect));
    NarikNgbSelect.decorators = [
        { type: core.Component, args: [{
                    selector: "narik-ngb-select , narik-select",
                    template: "<div class=\"form-group\">\r\n  <label for=\"{{id}}\">{{label}}</label>\r\n  <div class=\"input-group mb-3\" *ngIf=\"icon\">\r\n    <div class=\"input-group-prepend\">\r\n      <span class=\"input-group-text\"><i class=\"fa fa-{{icon}}\"></i></span>\r\n    </div>\r\n    <ng-container *ngTemplateOutlet=\"inputElement\"></ng-container>\r\n  </div>\r\n  <ng-container *ngIf=\"!icon\">\r\n    <ng-container *ngTemplateOutlet=\"inputElement\"></ng-container>\r\n  </ng-container>\r\n\r\n</div>\r\n<ng-template #inputElement>\r\n\r\n  <select [required]=\"required\" class=\"custom-select\" [(ngModel)]=\"value\" [attr.disabled]=\"disabled || null\"\r\n    id=\"{{id}}\">\r\n    <option *ngFor=\"let item of optionData\" [value]=\"item[valueField]\">{{item[displayField]}}</option>\r\n  </select>\r\n\r\n\r\n\r\n</ng-template>",
                    inputs: __spread(NARIK_DATA_DISPLAY_VALUE_INPUTS, NARIK_SELECT_INPUTS),
                    outputs: __spread(NARIK_DATA_DISPLAY_VALUE_OUTPUTS),
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(( /**
                             * @return {?}
                             */function () { return NarikNgbSelect; })),
                            multi: true
                        }
                    ],
                    styles: [".select-clear{left:-2px;position:absolute;top:-30px}.search-input{box-sizing:border-box;padding:16px}.search-continer{background-color:#fff;border-bottom:1px solid rgba(0,0,0,.12);position:-webkit-sticky;position:sticky;top:0;width:100%;z-index:10000}"]
                }] }
    ];
    /** @nocollapse */
    NarikNgbSelect.ctorParameters = function () { return [
        { type: core.Injector }
    ]; };
    NarikNgbSelect.propDecorators = {
        icon: [{ type: core.Input }]
    };
    if (false) {
        /** @type {?} */
        NarikNgbSelect.prototype.optionData;
        /** @type {?} */
        NarikNgbSelect.prototype.icon;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-select/narik-ngb-select.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgbSelectModule = /** @class */ (function () {
        function NarikNgbSelectModule() {
        }
        return NarikNgbSelectModule;
    }());
    NarikNgbSelectModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, forms.FormsModule],
                    declarations: [NarikNgbSelect],
                    exports: [NarikNgbSelect],
                    providers: []
                },] }
    ];

    var NarikNgbDynamicForm = /** @class */ (function (_super) {
        __extends(NarikNgbDynamicForm, _super);
        /**
         * @param {?} injector
         * @param {?} viewContainerRef
         */
        function NarikNgbDynamicForm(injector, viewContainerRef) {
            var _this = _super.call(this, injector, viewContainerRef) || this;
            _this.columnWidth = 100;
            _this.fieldsArray = new Map();
            return _this;
        }
        /**
         * @return {?}
         */
        NarikNgbDynamicForm.prototype.ngOnInit = function () {
            var _this = this;
            _super.prototype.ngOnInit.call(this);
            if (this.columnsCount === 1) {
                this.layoutGap = 0;
            }
            if (this.groupFields) {
                /** @type {?} */
                var data = common$1.groupBy(this.fields, 'options.groupIndex');
                data.forEach(( /**
                 * @param {?} x
                 * @return {?}
                 */function (x) { return _this.fieldsArray.set(x.key && x.key !== 'undefined' ? +x.key : 0, x.value); }));
                this.groupCount =
                    Math.max.apply(Math, __spread(this.fieldsArray.entriesArray().map(( /**
                     * @param {?} x
                     * @return {?}
                     */function (x) { return x.key; })))) + 1;
            }
            this.columnWidth = 100 / this.columnsCount;
        };
        return NarikNgbDynamicForm;
    }(uiCore.NarikDynamicForm));
    NarikNgbDynamicForm.decorators = [
        { type: core.Component, args: [{
                    selector: 'narik-dynamic-form , narik-ngb-dynamic-form',
                    template: "<div\r\n  [tab-guard]=\"activeTabGuard\"\r\n  [auto-focus]=\"activeAutoFocus\"\r\n  [autoFocusContainerName]=\"defaultFocusField\"\r\n  fxLayout=\"{{ columnsCount === 1 ? 'column' : 'row wrap' }} \"\r\n  fxLayout.xs=\"column\"\r\n  fxLayoutGap.xs=\"0\"\r\n  fxLayoutGap=\"{{ layoutGap }}px\"\r\n  fxLayoutAlign=\"flex-start\"\r\n>\r\n  <ng-container *ngIf=\"!groupFields\">\r\n    <div\r\n      fxFlex.gt-xs=\"0 1 calc({{ columnWidth }}% - {{ layoutGap }}px)\"\r\n      fxFlex=\"100%\"\r\n      *ngFor=\"let item of fields; let i = index\"\r\n    >\r\n      <ng-container\r\n        *ngTemplateOutlet=\"\r\n          fieldContainer;\r\n          context: {\r\n            $implicit: item,\r\n            invisibleItems: invisibleItems,\r\n            disableItems: disableItems,\r\n            model: model,\r\n            form: form\r\n          }\r\n        \"\r\n      ></ng-container>\r\n    </div>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"groupFields\">\r\n    <div\r\n      fxFlex.gt-xs=\"0 1 calc({{ columnWidth }}% - {{ layoutGap }}px)\"\r\n      fxFlex=\"100%\"\r\n      *ngFor=\"let item of [].constructor(groupCount); let i = index\"\r\n    >\r\n      <div fxLayout=\"column\" class=\"narik-form-group\">\r\n        <div *ngFor=\"let item of fieldsArray.get(i); let j = index\">\r\n          <ng-container\r\n            *ngTemplateOutlet=\"\r\n              fieldContainer;\r\n              context: {\r\n                $implicit: item,\r\n                invisibleItems: invisibleItems,\r\n                disableItems: disableItems,\r\n                model: model,\r\n                form: form\r\n              }\r\n            \"\r\n          ></ng-container>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </ng-container>\r\n</div>\r\n\r\n<ng-template\r\n  #fieldContainer\r\n  let-item\r\n  let-invisibleItems=\"invisibleItems\"\r\n  let-model=\"model\"\r\n  let-form=\"form\"\r\n  let-disableItems=\"disableItems\"\r\n>\r\n  <ng-container\r\n    [formGroup]=\"form\"\r\n    *ngIf=\"!item.hideExpr || !invisibleItems[item.name]\"\r\n  >\r\n    <ng-container *ngIf=\"!customFormComponentKeysObject[item.type || 'text']\">\r\n      <ng-container\r\n        *ngIf=\"\r\n          !item.type ||\r\n          item.type == 'text' ||\r\n          item.type == 'number' ||\r\n          item.type == 'time' ||\r\n          item.type == 'textArea' ||\r\n          item.type == 'password'\r\n        \"\r\n      >\r\n        <narik-input\r\n          [name]=\"item.name\"\r\n          [required]=\"item.required\"\r\n          placeHolder=\"{{ item.options.placeHolder | translate }}\"\r\n          [type]=\"item.type || 'text'\"\r\n          label=\"{{ item.label | translate }}\"\r\n          [formControlName]=\"item.model\"\r\n          [options]=\"item.options\"\r\n        >\r\n        </narik-input>\r\n      </ng-container>\r\n      <ng-container *ngIf=\"item.type == 'boolean'\">\r\n        <narik-checkbox\r\n          [name]=\"item.name\"\r\n          [options]=\"item.options\"\r\n          [formControlName]=\"item.model\"\r\n          label=\"{{ item.label | translate }}\"\r\n        >\r\n        </narik-checkbox>\r\n      </ng-container>\r\n      <ng-container *ngIf=\"item.type == 'date'\">\r\n        <narik-date-picker\r\n          [options]=\"item.options\"\r\n          [name]=\"item.name\"\r\n          [required]=\"item.required\"\r\n          placeHolder=\"{{ item.options.placeHolder | translate }}\"\r\n          [formControlName]=\"item.model\"\r\n          label=\"{{ item.label | translate }}\"\r\n        ></narik-date-picker>\r\n      </ng-container>\r\n      <ng-container *ngIf=\"item.type == 'select'\">\r\n        <narik-select\r\n          [options]=\"item.options\"\r\n          [name]=\"item.name\"\r\n          [required]=\"item.required\"\r\n          placeHolder=\"{{ item.options.placeHolder | translate }}\"\r\n          [dataInfo]=\"item.dataInfo\"\r\n          label=\"{{ item.label | translate }}\"\r\n          [formControlName]=\"item.model\"\r\n        ></narik-select>\r\n      </ng-container>\r\n      <ng-container *ngIf=\"item.type == 'autoComplete'\">\r\n        <narik-autocomplete\r\n          [options]=\"item.options\"\r\n          [name]=\"item.name\"\r\n          [required]=\"item.required\"\r\n          placeHolder=\"{{ item.options.placeHolder | translate }}\"\r\n          [minSearchLength]=\"item.options.minSearchLength || 0\"\r\n          [isLazyLoadData]=\"item.options.isLazyLoadData\"\r\n          [dataInfo]=\"item.dataInfo\"\r\n          label=\"{{ item.label | translate }}\"\r\n          [formControlName]=\"item.model\"\r\n        ></narik-autocomplete>\r\n      </ng-container>\r\n      <ng-container *ngIf=\"item.type == 'radio'\">\r\n        <narik-radio-group\r\n          [options]=\"item.options\"\r\n          [name]=\"item.name\"\r\n          [required]=\"item.required\"\r\n          placeHolder=\"{{ item.options.placeHolder | translate }}\"\r\n          [dataInfo]=\"item.dataInfo\"\r\n          label=\"{{ item.label | translate }}\"\r\n          [formControlName]=\"item.model\"\r\n        ></narik-radio-group>\r\n      </ng-container>\r\n      <ng-container *ngIf=\"item.type == 'checkList'\">\r\n        <narik-checkbox-list\r\n          [options]=\"item.options\"\r\n          [name]=\"item.name\"\r\n          [required]=\"item.required\"\r\n          placeHolder=\"{{ item.options.placeHolder | translate }}\"\r\n          [dataInfo]=\"item.dataInfo\"\r\n          label=\"{{ item.label | translate }}\"\r\n          [formControlName]=\"item.model\"\r\n        ></narik-checkbox-list>\r\n      </ng-container>\r\n      <ng-container *ngIf=\"item.type == 'table-select'\"> </ng-container>\r\n    </ng-container>\r\n    <ng-container *ngIf=\"customFormComponentKeysObject[item.type || 'text']\">\r\n      <ng-container\r\n        *narikComponentLoader=\"\r\n          customFormComponentKeysObject[item.type || 'text'];\r\n          bindings: {\r\n            field: item,\r\n            model: model\r\n          };\r\n          bindingSource: this;\r\n          parameters: {\r\n            form: form\r\n          }\r\n        \"\r\n      ></ng-container>\r\n    </ng-container>\r\n  </ng-container>\r\n</ng-template>\r\n",
                    providers: [
                        {
                            provide: uiCore.NarikDynamicForm,
                            useExisting: core.forwardRef(( /**
                             * @return {?}
                             */function () { return NarikNgbDynamicForm; })),
                        },
                    ]
                }] }
    ];
    /** @nocollapse */
    NarikNgbDynamicForm.ctorParameters = function () { return [
        { type: core.Injector },
        { type: core.ViewContainerRef }
    ]; };
    if (false) {
        /** @type {?} */
        NarikNgbDynamicForm.prototype.columnWidth;
        /** @type {?} */
        NarikNgbDynamicForm.prototype.groupCount;
        /** @type {?} */
        NarikNgbDynamicForm.prototype.fieldsArray;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-dynamic-form/narik-ngb-dynamic-form.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgbDynamicFormModule = /** @class */ (function () {
        function NarikNgbDynamicFormModule() {
        }
        return NarikNgbDynamicFormModule;
    }());
    NarikNgbDynamicFormModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.ReactiveFormsModule,
                        core$1.TranslateModule,
                        NarikNgbInputModule,
                        NarikNgbSelectModule,
                        NarikNgbCheckBoxModule,
                        NarikNgbRadioGroupModule,
                        NarikNgbAutoCompleteModule,
                        NarikNgbDatePickerModule,
                        NarikNgbCheckBoxListModule,
                        common$1.NarikCommonModule,
                        flexLayout.FlexLayoutModule,
                    ],
                    declarations: [NarikNgbDynamicForm],
                    exports: [NarikNgbDynamicForm],
                    providers: [],
                },] }
    ];

    var NarikNgbDialogContainer = /** @class */ (function (_super) {
        __extends(NarikNgbDialogContainer, _super);
        function NarikNgbDialogContainer() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @return {?}
         */
        NarikNgbDialogContainer.prototype.ngOnInit = function () { };
        return NarikNgbDialogContainer;
    }(core$2.NarikDialogContainer));
    NarikNgbDialogContainer.decorators = [
        { type: core.Component, args: [{
                    template: "<div\r\n  [@openClose]=\"isOpen ? 'open' : 'closed'\"\r\n  [class]=\"options.dialogCssClass\"\r\n  (@openClose.done)=\"_onAnimationDone($event)\"\r\n  class=\"modal-content\"\r\n  cdkDrag\r\n  [tab-guard]=\"true\"\r\n>\r\n  <div class=\"modal-header\">\r\n    <h5 cdkDragHandle class=\"modal-title\">{{ title | translate }}</h5>\r\n  </div>\r\n\r\n  <div class=\"modal-body\">\r\n    <ng-template narik-loader-host></ng-template>\r\n  </div>\r\n\r\n  <div\r\n    class=\"modal-footer\"\r\n    [auto-focus]=\"true\"\r\n    [autoFocusContainerName]=\"options.defaultAction\"\r\n    *ngIf=\"actions && actions.length !== 0\"\r\n    align=\"end\"\r\n  >\r\n    <ng-container *ngFor=\"let item of actions\">\r\n      <ng-container>\r\n        <narik-button\r\n          cssClass=\"btn-sm\"\r\n          [attr.narik-form-item-key]=\"item.dialogResult\"\r\n          class=\"mr-2\"\r\n          (nClick)=\"actionClick(item)\"\r\n          [color]=\"item.color\"\r\n          [icon]=\"item.icon\"\r\n          label=\"{{ 'dialog-buttons.' + item.label | translate }}\"\r\n        ></narik-button>\r\n      </ng-container>\r\n    </ng-container>\r\n  </div>\r\n</div>\r\n",
                    animations: [animations.trigger("openClose", core$2.DialogAnimationBody)],
                    styles: [".dialog-container{background-color:#fff;border-radius:5px;box-shadow:20px 20px 15px -7px rgba(0,0,0,.2),0 24px 38px 3px rgba(0,0,0,.14),0 9px 46px 8px rgba(0,0,0,.12)}"]
                }] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-dialog/narik-ngb-input-dialog.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgbInputDialog = /** @class */ (function () {
        /**
         * @param {?} parameters
         */
        function NarikNgbInputDialog(parameters) {
            this.entity = {};
            this.fields = [];
            if (parameters) {
                this.entity = parameters.entity;
                this.fields = parameters.fields;
            }
        }
        /**
         * @return {?}
         */
        NarikNgbInputDialog.prototype.ngOnInit = function () { };
        return NarikNgbInputDialog;
    }());
    NarikNgbInputDialog.decorators = [
        { type: core.Component, args: [{
                    template: "<div class=\"pr-2 pl-2\">\r\n  <narik-dynamic-form [model]=\"entity\" [fields]=\"fields\"></narik-dynamic-form>\r\n</div>\r\n"
                }] }
    ];
    /** @nocollapse */
    NarikNgbInputDialog.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core.Inject, args: [infrastructure.PARAMETERS,] }] }
    ]; };
    if (false) {
        /** @type {?} */
        NarikNgbInputDialog.prototype.entity;
        /** @type {?} */
        NarikNgbInputDialog.prototype.fields;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-dialog/narik-ngb-message-dialog.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgbMessageDialog = /** @class */ (function () {
        /**
         * @param {?} parameters
         */
        function NarikNgbMessageDialog(parameters) {
            if (parameters) {
                this.message = parameters.message;
            }
        }
        /**
         * @return {?}
         */
        NarikNgbMessageDialog.prototype.ngOnInit = function () { };
        return NarikNgbMessageDialog;
    }());
    NarikNgbMessageDialog.decorators = [
        { type: core.Component, args: [{
                    template: "<div class=\"message-container\">{{message | translate}}</div>\r\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    NarikNgbMessageDialog.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core.Inject, args: [infrastructure.PARAMETERS,] }] }
    ]; };
    if (false) {
        /** @type {?} */
        NarikNgbMessageDialog.prototype.message;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-dialog/narik-ngb-dialog.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ɵ0 = NarikNgbDialogContainer, ɵ1 = NarikNgbMessageDialog, ɵ2 = NarikNgbInputDialog;
    var NarikNgbDialogModule = /** @class */ (function () {
        function NarikNgbDialogModule() {
        }
        return NarikNgbDialogModule;
    }());
    NarikNgbDialogModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        core$1.TranslateModule,
                        common$1.NarikCommonModule,
                        NarikNgbButtonModule,
                        NarikNgbDynamicFormModule
                    ],
                    declarations: [
                        NarikNgbDialogContainer,
                        NarikNgbInputDialog,
                        NarikNgbMessageDialog
                    ],
                    exports: [
                        NarikNgbDialogContainer,
                        NarikNgbInputDialog,
                        NarikNgbMessageDialog
                    ],
                    providers: [
                        {
                            provide: infrastructure.DIALOG_CONTAINER,
                            useValue: ɵ0
                        },
                        {
                            provide: infrastructure.DIALOG_MESSAGE_COMPONENT,
                            useValue: ɵ1
                        },
                        {
                            provide: infrastructure.DIALOG_INPUT_COMPONENT,
                            useValue: ɵ2
                        }
                    ],
                    entryComponents: [
                        NarikNgbDialogContainer,
                        NarikNgbInputDialog,
                        NarikNgbMessageDialog
                    ]
                },] }
    ];

    var NarikNgbTreeview = /** @class */ (function (_super) {
        __extends(NarikNgbTreeview, _super);
        /**
         * @param {?} injector
         */
        function NarikNgbTreeview(injector) {
            return _super.call(this, injector) || this;
        }
        Object.defineProperty(NarikNgbTreeview.prototype, "selectedItem", {
            /**
             * @return {?}
             */
            get: function () {
                return this._selectedItem;
            },
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._selectedItem = value;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @param {?} selectedNode
         * @return {?}
         */
        NarikNgbTreeview.prototype.addNode = function (selectedNode) {
            throw new Error("Method not implemented.");
        };
        /**
         * @param {?} selectedNode
         * @return {?}
         */
        NarikNgbTreeview.prototype.deleteNode = function (selectedNode) {
            throw new Error("Method not implemented.");
        };
        return NarikNgbTreeview;
    }(uiCore.NarikTreeview));
    NarikNgbTreeview.decorators = [
        { type: core.Component, args: [{
                    selector: "narik-ngb-treeview narik-treeview",
                    template: ""
                }] }
    ];
    /** @nocollapse */
    NarikNgbTreeview.ctorParameters = function () { return [
        { type: core.Injector }
    ]; };
    NarikNgbTreeview.propDecorators = {
        newNodeTitle: [{ type: core.Input }]
    };
    if (false) {
        /** @type {?} */
        NarikNgbTreeview.prototype.newNodeTitle;
        /** @type {?} */
        NarikNgbTreeview.prototype._selectedItem;
    }

    var NarikNgbToolBar = /** @class */ (function (_super) {
        __extends(NarikNgbToolBar, _super);
        /**
         * @param {?} injector
         * @param {?} viewContainerRef
         */
        function NarikNgbToolBar(injector, viewContainerRef) {
            var _this = _super.call(this, injector, viewContainerRef) || this;
            _this.uniqueId = "";
            _this.toolbarItems = [];
            _this.uniqueId = "toolbar" + angular2Uuid.UUID.UUID();
            return _this;
        }
        /**
         * @return {?}
         */
        NarikNgbToolBar.prototype.ngOnInit = function () {
            var e_1, _a, e_2, _b, e_3, _c;
            _super.prototype.ngOnInit.call(this);
            /** @type {?} */
            var isnewGroup = false;
            /** @type {?} */
            var toolBarGroup = [];
            try {
                for (var _d = __values(this.items), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var item = _e.value;
                    if (item.itemType === "divider") {
                        isnewGroup = true;
                    }
                    if (item.itemType !== "divider") {
                        toolBarGroup.push(item);
                    }
                    if (isnewGroup) {
                        this.toolbarItems.push(__spread(toolBarGroup));
                        toolBarGroup = [];
                    }
                    isnewGroup = false;
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
                }
                finally { if (e_1) throw e_1.error; }
            }
            if (toolBarGroup.length !== 0) {
                this.toolbarItems.push(toolBarGroup);
            }
            try {
                for (var _f = __values(this.toolbarItems), _g = _f.next(); !_g.done; _g = _f.next()) {
                    var group = _g.value;
                    /** @type {?} */
                    var index = 0;
                    try {
                        for (var group_1 = (e_3 = void 0, __values(group)), group_1_1 = group_1.next(); !group_1_1.done; group_1_1 = group_1.next()) {
                            var item = group_1_1.value;
                            /** @type {?} */
                            var cssClass = "";
                            if (index !== 0) {
                                cssClass += " btn-not-first-child";
                            }
                            if (index !== group.length - 1) {
                                cssClass += " btn-not-last-child";
                            }
                            item.cssClass = (item.cssClass || "") + cssClass;
                            index++;
                        }
                    }
                    catch (e_3_1) { e_3 = { error: e_3_1 }; }
                    finally {
                        try {
                            if (group_1_1 && !group_1_1.done && (_c = group_1.return)) _c.call(group_1);
                        }
                        finally { if (e_3) throw e_3.error; }
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
                }
                finally { if (e_2) throw e_2.error; }
            }
        };
        return NarikNgbToolBar;
    }(uiCore.NarikToolBar));
    NarikNgbToolBar.decorators = [
        { type: core.Component, args: [{
                    selector: "narik-toolbar , narik-ngb-toolbar",
                    template: "<div class=\"btn-toolbar\" role=\"toolbar\" aria-label=\"Toolbar with button groups\">\r\n  <div class=\"btn-group mr-1\" *ngFor=\"let group of toolbarItems\">\r\n    <ng-container *ngFor=\"let item of group; let i = index\">\r\n      <ng-container *ngIf=\"item.itemType === 'button'\">\r\n        <narik-button\r\n          class=\"toolbar-btn\"\r\n          *ngIf=\"!item.hideExpr || !invisibleItems[item.key]\"\r\n          [disable]=\"item.disableExpr && disableItems[item.key]\"\r\n          [isBusy]=\"item.busyExpr && busyItems[item.key]\"\r\n          [cssClass]=\"item.cssClass\"\r\n          (nClick)=\"itemCommand(item)\"\r\n          [buttonStyle]=\"'secondary'\"\r\n          [icon]=\"item.icon\"\r\n          ngbTooltip=\"{{\r\n            (item.tooltip ? (item.tooltip | translate) : '') +\r\n              (options.appendShortcutToTooltip && item.shortcut\r\n                ? '(' + (item.shortcut | shortcut) + ')'\r\n                : '')\r\n          }}\"\r\n          container=\"body\"\r\n          [label]=\"showLabel ? item.label : ''\"\r\n        ></narik-button>\r\n      </ng-container>\r\n    </ng-container>\r\n  </div>\r\n</div>\r\n"
                }] }
    ];
    /** @nocollapse */
    NarikNgbToolBar.ctorParameters = function () { return [
        { type: core.Injector },
        { type: core.ViewContainerRef }
    ]; };
    if (false) {
        /** @type {?} */
        NarikNgbToolBar.prototype.uniqueId;
        /** @type {?} */
        NarikNgbToolBar.prototype.toolbarItems;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-toolbar/narik-ngb-toolbar.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgbToolbarModule = /** @class */ (function () {
        function NarikNgbToolbarModule() {
        }
        return NarikNgbToolbarModule;
    }());
    NarikNgbToolbarModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        NarikNgbButtonModule,
                        core$1.TranslateModule,
                        ngBootstrap.NgbTooltipModule,
                        common$1.NarikCommonModule
                    ],
                    declarations: [NarikNgbToolBar],
                    exports: [NarikNgbToolBar],
                    providers: []
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-treeview/narik-ngb-treeview.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgbTreeviewModule = /** @class */ (function () {
        function NarikNgbTreeviewModule() {
        }
        return NarikNgbTreeviewModule;
    }());
    NarikNgbTreeviewModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        NarikNgbToolbarModule,
                        core$1.TranslateModule
                    ],
                    declarations: [NarikNgbTreeview],
                    exports: [NarikNgbTreeview],
                    providers: []
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-core/narik-ngb-core.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgbCoreModule = /** @class */ (function () {
        function NarikNgbCoreModule() {
        }
        return NarikNgbCoreModule;
    }());
    NarikNgbCoreModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: [],
                    exports: [],
                    providers: []
                },] }
    ];

    var NarikNgbTabOutlet = /** @class */ (function (_super) {
        __extends(NarikNgbTabOutlet, _super);
        /**
         * @param {?} injector
         * @param {?} zone
         */
        function NarikNgbTabOutlet(injector, zone) {
            var _this = _super.call(this, injector) || this;
            _this.zone = zone;
            return _this;
        }
        /**
         * @param {?} index
         * @return {?}
         */
        NarikNgbTabOutlet.prototype.removeTabItem = function (index) {
            this.removeTab(index);
            return false;
        };
        /**
         * @param {?} tab
         * @return {?}
         */
        NarikNgbTabOutlet.prototype.addView = function (tab) {
            var _this = this;
            _super.prototype.addView.call(this, tab);
            this.zone.onStable
                .pipe(operators.take(1))
                .subscribe(( /**
         * @return {?}
         */function () { return _this.navElement.select(tab.uniqueId); }));
        };
        return NarikNgbTabOutlet;
    }(uiCore.NarikTabOutlet));
    NarikNgbTabOutlet.decorators = [
        { type: core.Component, args: [{
                    selector: "narik-ngb-tab-outlet , narik-tab-outlet",
                    template: "<div>\r\n  <nav ngbNav #nav=\"ngbNav\" [destroyOnHide]=\"false\" class=\"nav-tabs\">\r\n    <ng-container\r\n      ngbNavItem=\"tab.uniqueId\"\r\n      *ngFor=\"let tab of tabs; let index = index; trackBy: trackByFn\"\r\n    >\r\n      <ng-template ngbNavContent>\r\n        <div class=\"p-1\">\r\n          <ng-container *ngIf=\"tab.component\">\r\n            <ng-container\r\n              *narikComponentLoader=\"\r\n                tab.component;\r\n                parameters: tab.data;\r\n                providers: tab.providers\r\n              \"\r\n            ></ng-container>\r\n          </ng-container>\r\n        </div>\r\n      </ng-template>\r\n      <ng-template ngbNavLink>\r\n        <div class=\"title-container\">\r\n          <span>{{ tab.title | translate }}</span>\r\n          <i (click)=\"removeTabItem(index)\" class=\"fas fa-times close-btn ml-2\">\r\n          </i>\r\n        </div>\r\n      </ng-template>\r\n    </ng-container>\r\n  </nav>\r\n</div>\r\n",
                    styles: [".close-btn{color:red;cursor:pointer}.title-container{display:\"flex\";justify-content:space-between}"]
                }] }
    ];
    /** @nocollapse */
    NarikNgbTabOutlet.ctorParameters = function () { return [
        { type: core.Injector },
        { type: core.NgZone }
    ]; };
    NarikNgbTabOutlet.propDecorators = {
        navElement: [{ type: core.ViewChild, args: ["nav", { static: true },] }]
    };
    if (false) {
        /** @type {?} */
        NarikNgbTabOutlet.prototype.navElement;
        /**
         * @type {?}
         * @private
         */
        NarikNgbTabOutlet.prototype.zone;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-tab-outlet/narik-ngb-tab-outlet.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikNgbTabOutletModule = /** @class */ (function () {
        function NarikNgbTabOutletModule() {
        }
        return NarikNgbTabOutletModule;
    }());
    NarikNgbTabOutletModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, core$1.TranslateModule, common$1.NarikCommonModule, ngBootstrap.NgbNavModule],
                    declarations: [NarikNgbTabOutlet],
                    exports: [NarikNgbTabOutlet],
                    providers: [],
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ui-ng-bootstrap.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NarikUiNgBootstrapModule = /** @class */ (function () {
        function NarikUiNgBootstrapModule() {
        }
        return NarikUiNgBootstrapModule;
    }());
    NarikUiNgBootstrapModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        core$1.TranslateModule,
                        NarikNgbAutoCompleteModule,
                        NarikNgbBusyIndicatorModule,
                        NarikNgbButtonModule,
                        NarikNgbCheckBoxModule,
                        NarikNgbCheckBoxListModule,
                        NarikNgbDataTableModule,
                        NarikNgbDatePickerModule,
                        NarikNgbDialogModule,
                        NarikNgbDynamicFormModule,
                        NarikNgbInputModule,
                        NarikNgbRadioGroupModule,
                        NarikNgbSelectModule,
                        NarikNgbToolbarModule,
                        NarikNgbTreeviewModule,
                        NarikNgbCoreModule,
                        NarikNgbTabOutletModule
                    ],
                    declarations: [],
                    exports: [
                        core$1.TranslateModule,
                        NarikNgbAutoCompleteModule,
                        NarikNgbBusyIndicatorModule,
                        NarikNgbButtonModule,
                        NarikNgbCheckBoxModule,
                        NarikNgbCheckBoxListModule,
                        NarikNgbDataTableModule,
                        NarikNgbDatePickerModule,
                        NarikNgbDialogModule,
                        NarikNgbDynamicFormModule,
                        NarikNgbInputModule,
                        NarikNgbRadioGroupModule,
                        NarikNgbSelectModule,
                        NarikNgbToolbarModule,
                        NarikNgbTreeviewModule,
                        NarikNgbCoreModule,
                        NarikNgbTabOutletModule
                    ],
                    providers: []
                },] }
    ];

    /**
     * @template T
     */
    var NarikUiListForm = /** @class */ (function (_super) {
        __extends(NarikUiListForm, _super);
        /**
         * @param {?} injector
         */
        function NarikUiListForm(injector) {
            var _this = _super.call(this, injector) || this;
            _this.ds = [];
            _this.hasDataSource = false;
            return _this;
        }
        Object.defineProperty(NarikUiListForm.prototype, "isServerSide", {
            /**
             * @return {?}
             */
            get: function () {
                return this.config && this.config.isServerSideData ? true : false;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @return {?}
         */
        NarikUiListForm.prototype.ngOnInit = function () {
            _super.prototype.ngOnInit.call(this);
            if (this.fields) {
            }
            if (this.config) {
                if (this.isServerSide) {
                    /** @type {?} */
                    var that = this;
                }
            }
        };
        /**
         * @return {?}
         */
        NarikUiListForm.prototype.ngAfterViewInit = function () { };
        /**
         * @param {?} result
         * @return {?}
         */
        NarikUiListForm.prototype.useData = function (result) {
            this.dataSource = ( /** @type {?} */(result.data));
        };
        /**
         * @protected
         * @param {?=} remoteDaraParams
         * @return {?}
         */
        NarikUiListForm.prototype.refresh = function (remoteDaraParams) {
            if (!this.isServerSide) {
                this.getEntities();
            }
            else {
            }
        };
        return NarikUiListForm;
    }(appCore.NarikListForm));
    __decorate([
        core$2.NarikInject(core$1.TranslateService),
        __metadata("design:type", core$1.TranslateService)
    ], NarikUiListForm.prototype, "translateService", void 0);
    if (false) {
        /** @type {?} */
        NarikUiListForm.prototype.ds;
        /** @type {?} */
        NarikUiListForm.prototype.translateService;
    }

    /**
     * @template T
     */
    var NarikUiEditForm = /** @class */ (function (_super) {
        __extends(NarikUiEditForm, _super);
        /**
         * @param {?} injector
         */
        function NarikUiEditForm(injector) {
            return _super.call(this, injector) || this;
        }
        /**
         * @return {?}
         */
        NarikUiEditForm.prototype.submit = function () {
            if (this.formElement) {
                this.renderer.addClass(this.formElement.nativeElement, "was-validated");
            }
            _super.prototype.submit.call(this);
        };
        return NarikUiEditForm;
    }(appCore.NarikEditForm));
    __decorate([
        core$2.NarikInject(core.Renderer2),
        __metadata("design:type", core.Renderer2)
    ], NarikUiEditForm.prototype, "renderer", void 0);
    if (false) {
        /** @type {?} */
        NarikUiEditForm.prototype.renderer;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/base/public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-auto-complete/public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-busy-indicator/public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-button/public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-check-box/public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-check-box-list/public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-input/public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-radio/public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-select/public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-toolbar/public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-dynamic-form/public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-treeview/public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-dialog/public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-data-table/public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-core/public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/narik-ngb-tab-outlet/public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: narik-ui-ng-bootstrap.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NarikNgbAutoComplete = NarikNgbAutoComplete;
    exports.NarikNgbAutoCompleteModule = NarikNgbAutoCompleteModule;
    exports.NarikNgbBusyIndicator = NarikNgbBusyIndicator;
    exports.NarikNgbBusyIndicatorModule = NarikNgbBusyIndicatorModule;
    exports.NarikNgbButtonComponent = NarikNgbButtonComponent;
    exports.NarikNgbButtonModule = NarikNgbButtonModule;
    exports.NarikNgbCheckBox = NarikNgbCheckBox;
    exports.NarikNgbCheckBoxList = NarikNgbCheckBoxList;
    exports.NarikNgbCheckBoxListModule = NarikNgbCheckBoxListModule;
    exports.NarikNgbCheckBoxModule = NarikNgbCheckBoxModule;
    exports.NarikNgbCoreModule = NarikNgbCoreModule;
    exports.NarikNgbDataTable = NarikNgbDataTable;
    exports.NarikNgbDataTableModule = NarikNgbDataTableModule;
    exports.NarikNgbDatePicker = NarikNgbDatePicker;
    exports.NarikNgbDatePickerModule = NarikNgbDatePickerModule;
    exports.NarikNgbDialogContainer = NarikNgbDialogContainer;
    exports.NarikNgbDialogModule = NarikNgbDialogModule;
    exports.NarikNgbDynamicForm = NarikNgbDynamicForm;
    exports.NarikNgbDynamicFormModule = NarikNgbDynamicFormModule;
    exports.NarikNgbInput = NarikNgbInput;
    exports.NarikNgbInputDialog = NarikNgbInputDialog;
    exports.NarikNgbInputModule = NarikNgbInputModule;
    exports.NarikNgbMessageDialog = NarikNgbMessageDialog;
    exports.NarikNgbRadioGroup = NarikNgbRadioGroup;
    exports.NarikNgbRadioGroupModule = NarikNgbRadioGroupModule;
    exports.NarikNgbSelect = NarikNgbSelect;
    exports.NarikNgbSelectModule = NarikNgbSelectModule;
    exports.NarikNgbTabOutlet = NarikNgbTabOutlet;
    exports.NarikNgbTabOutletModule = NarikNgbTabOutletModule;
    exports.NarikNgbToolBar = NarikNgbToolBar;
    exports.NarikNgbToolbarModule = NarikNgbToolbarModule;
    exports.NarikNgbTreeview = NarikNgbTreeview;
    exports.NarikNgbTreeviewModule = NarikNgbTreeviewModule;
    exports.NarikUiEditForm = NarikUiEditForm;
    exports.NarikUiListForm = NarikUiListForm;
    exports.NarikUiNgBootstrapModule = NarikUiNgBootstrapModule;
    exports.ɵa = NARIK_UI_COMPONENT_INPUTS;
    exports.ɵb = NARIK_UI_FORM_INPUTS;
    exports.ɵc = NARIK_DATA_ORIENTED_OUTPUTS;
    exports.ɵd = NARIK_DATA_ORIENTED_INPUTS;
    exports.ɵe = NARIK_DATA_DISPLAY_VALUE_OUTPUTS;
    exports.ɵf = NARIK_DATA_DISPLAY_VALUE_INPUTS;
    exports.ɵg = NARIK_CHECKBOX_INPUTS;
    exports.ɵh = NARIK_SELECT_INPUTS;
    exports.ɵi = NARIK_DATE_PICKER_INPUTS;
    exports.ɵj = NARIK_INPUT_INPUTS;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=narik-ui-ng-bootstrap.umd.js.map
